## nodejs 22.22.0%2Bdfsg%2B~cs22.19.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(ada
  DESCRIPTION "Fast spec-compliant URL parser"
  LANGUAGES C CXX
  VERSION 3.4.1
)
set(ADA_LIB_VERSION "3.4.1" CACHE STRING "ada library version")
set(ADA_LIB_SOVERSION "3" CACHE STRING "ada library soversion")

include(GNUInstallDirs)

include(CTest)
include(cmake/ada-flags.cmake)

add_subdirectory(src)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/scripts/cmake)
option(ADA_TESTING "Whether to build tests." OFF)
option(ADA_BENCHMARKS "Whether to build benchmarks." OFF)
option(ADA_TOOLS "Whether to build tools." OFF)
option(ADA_BUILD_SINGLE_HEADER_LIB "Whether to build the lib from the single-header files" OFF)
option(ADA_USE_SIMDUTF "Whether to use SIMDUTF for IDNA" OFF)
# There are cases where when embedding ada as a dependency for other CMake
# projects as submodules or subdirectories (via FetchContent) can lead to
# errors due to CPM, so this is here to support disabling all the testing
# and tooling for ada if one only wishes to use the ada library.
if(ADA_TESTING OR ADA_BENCHMARKS OR ADA_TOOLS)
  include(cmake/CPM.cmake)
  # CPM requires git as an implicit dependency
  # We use googletest in the tests
  if(ADA_TESTING)
    CPMAddPackage(
      NAME GTest
      GITHUB_REPOSITORY google/googletest
      VERSION 1.15.2
      OPTIONS  "BUILD_GMOCK OFF" "INSTALL_GTEST OFF"
    )
  endif()
  # We use simdjson in both the benchmarks and tests
  if(ADA_TESTING OR ADA_BENCHMARKS)
    CPMAddPackage("gh:simdjson/simdjson@3.10.1")
  endif()
  # We use Google Benchmark, but it does not build under several 32-bit systems.
  if(ADA_BENCHMARKS AND (CMAKE_SIZEOF_VOID_P EQUAL 8))
    if(DEFINED CODSPEED_MODE)
      message(STATUS "Using CodSpeed-instrumented Google Benchmark")
      CPMAddPackage(
        NAME benchmark
        GITHUB_REPOSITORY CodSpeedHQ/codspeed-cpp
        VERSION 2.0.0
        SOURCE_SUBDIR google_benchmark
        OPTIONS "BENCHMARK_ENABLE_TESTING OFF"
                "BENCHMARK_ENABLE_INSTALL OFF"
                "BENCHMARK_ENABLE_WERROR OFF"
      )
    else()
      message(STATUS "Using standard Google Benchmark")
      CPMAddPackage(
        NAME benchmark
        GITHUB_REPOSITORY google/benchmark
        VERSION 1.9.0
        OPTIONS "BENCHMARK_ENABLE_TESTING OFF"
                "BENCHMARK_ENABLE_INSTALL OFF"
                "BENCHMARK_ENABLE_WERROR OFF"
      )
    endif()
  endif()

  if (ADA_TESTING AND NOT EMSCRIPTEN)
    set(CTEST_TEST_TIMEOUT 5)
    set(ADA_USE_UNSAFE_STD_REGEX_PROVIDER ON)
    message(STATUS "The tests are enabled.")
    add_subdirectory(tests)
  else()
    if(is_top_project)
      message(STATUS "The tests are disabled.")
    endif()
  endif(ADA_TESTING AND NOT EMSCRIPTEN)

  If(ADA_BENCHMARKS AND NOT EMSCRIPTEN)
    message(STATUS "Ada benchmarks enabled.")
    add_subdirectory(benchmarks)
  else(ADA_BENCHMARKS AND NOT EMSCRIPTEN)
    if(is_top_project)
      message(STATUS "Ada benchmarks disabled. Set ADA_BENCHMARKS=ON to enable them.")
    endif()
  endif(ADA_BENCHMARKS AND NOT EMSCRIPTEN)

  if (ADA_TESTING AND EMSCRIPTEN)
    add_subdirectory(tests/wasm)
  endif(ADA_TESTING AND EMSCRIPTEN)
endif()

if(ADA_USE_SIMDUTF)
  CPMAddPackage(
    NAME simdutf
    GITHUB_REPOSITORY simdutf/simdutf
    VERSION 7.3.2
    OPTIONS "SIMDUTF_TESTS OFF" "SIMDUTF_TOOLS OFF"
  )
endif()

add_library(ada::ada ALIAS ada)

if(ADA_TESTING OR ADA_USE_UNSAFE_STD_REGEX_PROVIDER)
  # IMPORTANT!
  #
  # We enable std_regex_provider for testing purposes
  # It is not recommended to enable this flag and use std::regex under
  # production environments due to several security issues.
  #
  target_compile_definitions(ada PUBLIC ADA_USE_UNSAFE_STD_REGEX_PROVIDER=ON)
endif()

set_target_properties(
  ada PROPERTIES
  VERSION "${ADA_LIB_VERSION}"
  SOVERSION "${ADA_LIB_SOVERSION}"
  WINDOWS_EXPORT_ALL_SYMBOLS YES
)

include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

if(NOT ADA_COVERAGE AND NOT EMSCRIPTEN)
  add_subdirectory(singleheader)
endif()

if(ADA_TOOLS)
  add_subdirectory(tools)
endif()

install(
  FILES include/ada.h include/ada_c.h
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
  COMPONENT ada_development
)

install(
  DIRECTORY include/ada
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
  COMPONENT ada_development
)

install(
  TARGETS ada
  EXPORT ada_targets
  RUNTIME COMPONENT ada_runtime
  LIBRARY COMPONENT ada_runtime
  NAMELINK_COMPONENT ada_development
  ARCHIVE COMPONENT ada_development
  INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
)

configure_file(cmake/ada-config.cmake.in ada-config.cmake @ONLY)

write_basic_package_version_file(
  ada-config-version.cmake
  COMPATIBILITY SameMinorVersion
)

set(
  ADA_INSTALL_CMAKEDIR "${CMAKE_INSTALL_LIBDIR}/cmake/ada"
  CACHE STRING "CMake package config location relative to the install prefix"
)
mark_as_advanced(ADA_INSTALL_CMAKEDIR)

install(
  FILES
  "${PROJECT_BINARY_DIR}/ada-config.cmake"
  "${PROJECT_BINARY_DIR}/ada-config-version.cmake"
  DESTINATION "${ADA_INSTALL_CMAKEDIR}"
  COMPONENT ada_development
)

install(
  EXPORT ada_targets
  NAMESPACE ada::
  DESTINATION "${ADA_INSTALL_CMAKEDIR}"
  COMPONENT ada_development
)

install(
  EXPORT ada_targets
  NAMESPACE ada::
  DESTINATION "${ADA_INSTALL_CMAKEDIR}"
  COMPONENT example_development
)


# pkg-config
include(cmake/JoinPaths.cmake)
join_paths(PKGCONFIG_INCLUDEDIR "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}")
join_paths(PKGCONFIG_LIBDIR "\${prefix}" "${CMAKE_INSTALL_LIBDIR}")

configure_file("ada.pc.in" "ada.pc" @ONLY)
install(
  FILES "${CMAKE_CURRENT_BINARY_DIR}/ada.pc"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
)

if(is_top_project)
  set(CPACK_PACKAGE_VENDOR "Ada Authors")
  set(CPACK_PACKAGE_CONTACT "yagiz@nizipli.com")
  set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE-MIT")
  set(CPACK_RPM_PACKAGE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE-MIT")
  set(CPACK_RESOURCE_FILE_README "${PROJECT_SOURCE_DIR}/README.md")
  set(CPACK_SOURCE_GENERATOR "TGZ;ZIP")
  include(CPack)
endif()

## nodejs 22.22.0+dfsg+~cs22.19.6

=== debian/changelog ===
nodejs (22.22.0+dfsg+~cs22.19.6-1ubuntu3) resolute; urgency=medium

  * Rebuild against latest simdutf

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 08 Feb 2026 10:56:39 -0500

nodejs (22.22.0+dfsg+~cs22.19.6-1ubuntu2) resolute; urgency=medium

  * Apply another upstream fix (PR: #58953) to fix a test failure

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 20 Jan 2026 14:01:42 +0100

nodejs (22.22.0+dfsg+~cs22.19.6-1ubuntu1) resolute; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - cherry-pick upstream fix for new icu 78.2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 19 Jan 2026 06:37:40 +0100

nodejs (22.22.0+dfsg+~cs22.19.6-1) unstable; urgency=medium

  * New upstream version 22.22.0+dfsg+~cs22.19.6
    + CVE-2025-59465 lib: add TLSSocket default error handler
    + CVE-2025-55132 lib: disable futimes when permission model is enabled
    + CVE-2025-55130 lib,permission: require full read and write to symlink APIs
    + CVE-2025-59466 src: rethrow stack overflow exceptions in async_hooks
    + CVE-2025-55131 src,lib: refactor unsafe buffer creation to remove zero-fill toggle
    + CVE-2026-21637 tls: route callback exceptions through error handlers

 -- Jérémy Lal <kapouer@melix.org>  Wed, 14 Jan 2026 01:19:18 +0100

nodejs (22.21.1+dfsg+~cs22.19.0-6ubuntu4) resolute; urgency=medium

  * Revert the test result ignore, new icu has fixed the upstream regressions:
    - Ignore test results, some icu regressions needs to be fixed, but unblock
      for now nodejs
  * Remaining delta: 8464435d688f06f606a0f68917d008fdb5308c2d.patch

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 11 Jan 2026 09:28:26 +0100

nodejs (22.21.1+dfsg+~cs22.19.0-6ubuntu3) resolute; urgency=medium

  * debian/patches/8464435d688f06f606a0f68917d008fdb5308c2d.patch:
    - cherry-pick upstream fix for new icu 78.2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 10 Jan 2026 17:12:19 +0100

nodejs (22.21.1+dfsg+~cs22.19.0-6ubuntu2) resolute; urgency=medium

  * No-change rebuild for libsimdjson29.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 08 Jan 2026 21:24:12 +0000

nodejs (22.21.1+dfsg+~cs22.19.0-6ubuntu1) resolute; urgency=medium

  * Ignore test results, some icu regressions needs to be fixed, but unblock
    for now nodejs

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 16 Dec 2025 08:23:26 +0100

nodejs (22.21.1+dfsg+~cs22.19.0-6) unstable; urgency=medium

  * Add parallel/test-http-keep-alive-empty-line as flaky
  * Revert "Drop ada component"

 -- Jérémy Lal <kapouer@melix.org>  Mon, 08 Dec 2025 00:23:49 +0100

nodejs (22.21.1+dfsg+~cs22.19.0-5) unstable; urgency=medium

  * Restore libnode127 Breaks/Replaces previous ones.
    Was removed for "nodejs" but this is actually needed
    for transitions to happen. 

 -- Jérémy Lal <kapouer@melix.org>  Fri, 21 Nov 2025 07:48:37 +0100

nodejs (22.21.1+dfsg+~cs22.19.0-4) unstable; urgency=medium

  * More flaky tests on riscv64

 -- Jérémy Lal <kapouer@melix.org>  Wed, 19 Nov 2025 14:12:26 +0100

nodejs (22.21.1+dfsg+~cs22.19.0-3) experimental; urgency=medium

  * patch: upstream commit riscv64. Closes: #1090073

 -- Jérémy Lal <kapouer@melix.org>  Tue, 11 Nov 2025 13:19:34 +0100

## nodejs 22.22.0+dfsg+~cs22.19.7

=== benchmarks/CMakeLists.txt ===
# Performance counters
CPMAddPackage(
  NAME counters
  GITHUB_REPOSITORY lemire/counters
  GIT_TAG v2.2.0
)

# bench_search_params
add_executable(bench_search_params bench_search_params.cpp)
target_link_libraries(bench_search_params PRIVATE ada counters::counters)

add_executable(urlpattern urlpattern.cpp)
target_link_libraries(urlpattern PRIVATE ada counters::counters)
target_include_directories(urlpattern PUBLIC "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>")
target_include_directories(urlpattern PUBLIC "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/benchmarks>")

# Bench
add_executable(wpt_bench wpt_bench.cpp)
target_link_libraries(wpt_bench PRIVATE ada counters::counters)
target_link_libraries(wpt_bench PRIVATE simdjson)
target_include_directories(wpt_bench PUBLIC "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>")
target_include_directories(wpt_bench PUBLIC "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/benchmarks>")

# Bench
add_executable(bench bench.cpp)
target_link_libraries(bench PRIVATE ada counters::counters)
target_include_directories(bench PUBLIC "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>")
target_include_directories(bench PUBLIC "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/benchmarks>")

# Benchdata
CPMAddPackage("gh:ada-url/url-dataset#9749b92c13e970e70409948fa862461191504ccc")
add_executable(benchdata bench.cpp)
target_link_libraries(benchdata PRIVATE ada counters::counters)
target_include_directories(benchdata PUBLIC "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>")
target_include_directories(benchdata PUBLIC "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/benchmarks>")
target_compile_definitions(benchdata PRIVATE ADA_URL_FILE="${url-dataset_SOURCE_DIR}/out.txt")
target_compile_definitions(benchdata PRIVATE BENCHMARK_PREFIX=BenchData_)
target_compile_definitions(benchdata PRIVATE BENCHMARK_PREFIX_STR="BenchData_")


# BBC Bench
add_executable(bbc_bench bbc_bench.cpp)
target_link_libraries(bbc_bench PRIVATE ada counters::counters)
target_include_directories(bbc_bench PUBLIC "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>")
target_include_directories(bbc_bench PUBLIC "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/benchmarks>")

# bench_ipv4
add_executable(bench_ipv4 bench_ipv4.cpp)
target_link_libraries(bench_ipv4 PRIVATE ada counters::counters)
target_include_directories(bench_ipv4 PUBLIC "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>")
target_include_directories(bench_ipv4 PUBLIC "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/benchmarks>")
target_compile_definitions(bench_ipv4 PRIVATE ADA_URL_FILE="${url-dataset_SOURCE_DIR}/out.txt")

# Percent Encode
add_executable(percent_encode percent_encode.cpp)
target_link_libraries(percent_encode PRIVATE ada counters::counters)
target_include_directories(percent_encode PUBLIC "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>")
target_include_directories(percent_encode PUBLIC "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/benchmarks>")
if(MSVC AND BUILD_SHARED_LIBS)
  # Copy the ada dll into the directory
  add_custom_command(TARGET percent_encode POST_BUILD        # Adds a post-build event
    COMMAND ${CMAKE_COMMAND} -E copy_if_different  # which executes "cmake -E copy_if_different..."
        "$<TARGET_FILE:ada>"      # <--this is in-file
        "$<TARGET_FILE_DIR:percent_encode>")                 # <--this is out-file path
endif()

add_executable(model_bench model_bench.cpp)
target_link_libraries(model_bench PRIVATE ada counters::counters)
target_compile_definitions(model_bench PRIVATE ADA_URL_FILE="${url-dataset_SOURCE_DIR}/out.txt")

target_link_libraries(wpt_bench PRIVATE benchmark::benchmark)
target_link_libraries(bench PRIVATE benchmark::benchmark)
target_link_libraries(benchdata PRIVATE benchmark::benchmark)
target_link_libraries(bbc_bench PRIVATE benchmark::benchmark)
target_link_libraries(bench_ipv4 PRIVATE benchmark::benchmark)
target_link_libraries(percent_encode PRIVATE benchmark::benchmark)
target_link_libraries(bench_search_params PRIVATE benchmark::benchmark)
target_link_libraries(urlpattern PRIVATE benchmark::benchmark)

set(BENCHMARKS wpt_bench bench benchdata bbc_bench bench_ipv4 percent_encode bench_search_params urlpattern)

add_custom_target(run_all_benchmarks
        COMMAND ${CMAKE_COMMAND} -E echo "Running all benchmarks..."
)
foreach(benchmark IN LISTS BENCHMARKS)
    add_custom_command(
            TARGET run_all_benchmarks
            POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E echo "Running ${benchmark}..."
            COMMAND $<TARGET_FILE:${benchmark}> --benchmark_min_time=1s
            WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )
endforeach()

option(ADA_COMPETITION "Whether to install various competitors." OFF)

# We only build url_whatwg if ICU is found, so we need to make
# finding ICU easy.

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  message(STATUS "Apple system detected.")
  # People who run macOS often use brew.
  if(EXISTS /opt/homebrew/opt/icu4c)
    message(STATUS "icu is provided by homebrew at /opt/homebrew/opt/icu4c.")
    ## This is a bit awkward, but it is a lot better than asking the
    ## user to figure that out.
    list(APPEND CMAKE_PREFIX_PATH "/opt/homebrew/opt/icu4c/include")
    list(APPEND CMAKE_LIBRARY_PATH "/opt/homebrew/opt/icu4c/lib")
  elseif(EXISTS /usr/local/opt/icu4c)
    message(STATUS "icu is provided by homebrew at /usr/local/opt/icu4c.")
    list(APPEND CMAKE_PREFIX_PATH "/usr/local/opt/icu4c/include")
    list(APPEND CMAKE_LIBRARY_PATH "/usr/local/opt/icu4c/lib")
  endif()
endif()

find_package(ICU COMPONENTS uc i18n)
### If the user does not have ICU, let us help them with instructions:
if(NOT ICU_FOUND)
  if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
      if(EXISTS /opt/homebrew)
        message(STATUS "Under macOS, you may install ICU with brew, using 'brew install icu4c'.")
      else()
        message(STATUS "Under macOS, you should install brew (see https://brew.sh) and then icu4c ('brew install icu4c').")
      endif()
  elseif(CMAKE_SYSTEM_NAME STREQUAL "Linux")
      message(STATUS "Under Linux, you may be able to install ICU with a command such as 'apt-get install libicu-dev'." )
  endif()
endif(NOT ICU_FOUND)

if(ICU_FOUND)
    CPMAddPackage(
      NAME url_whatwg
      GITHUB_REPOSITORY rmisev/url_whatwg
      GIT_TAG 72bcabf
      OPTIONS  "URL_BUILD_TESTS OFF" "URL_USE_LIBS OFF"
    )
    add_library(url_whatwg_lib STATIC "${url_whatwg_SOURCE_DIR}/src/url.cpp"
      "${url_whatwg_SOURCE_DIR}/src/url_idna.cpp"
      "${url_whatwg_SOURCE_DIR}/src/url_ip.cpp"
      "${url_whatwg_SOURCE_DIR}/src/url_percent_encode.cpp"
      "${url_whatwg_SOURCE_DIR}/src/url_search_params.cpp"
      "${url_whatwg_SOURCE_DIR}/src/url_utf.cpp"
      "${url_whatwg_SOURCE_DIR}/src/url.cpp")
    target_include_directories(url_whatwg_lib PUBLIC "${url_whatwg_SOURCE_DIR}/include")
    target_link_libraries(url_whatwg_lib PRIVATE ICU::uc ICU::i18n)


    target_link_libraries(bench PRIVATE url_whatwg_lib)
    target_link_libraries(benchdata PRIVATE url_whatwg_lib)
    target_link_libraries(bbc_bench PRIVATE url_whatwg_lib)
    target_link_libraries(wpt_bench PRIVATE url_whatwg_lib)

    target_include_directories(bench PUBLIC "${url_whatwg_SOURCE_DIR}")
    target_include_directories(benchdata PUBLIC "${url_whatwg_SOURCE_DIR}")
    target_include_directories(bbc_bench PUBLIC "${url_whatwg_SOURCE_DIR}")
    target_include_directories(wpt_bench PUBLIC "${url_whatwg_SOURCE_DIR}")

    target_compile_definitions(bench PRIVATE ADA_url_whatwg_ENABLED=1)
    target_compile_definitions(benchdata PRIVATE ADA_url_whatwg_ENABLED=1)
    target_compile_definitions(bbc_bench PRIVATE ADA_url_whatwg_ENABLED=1)
    target_compile_definitions(wpt_bench PRIVATE ADA_url_whatwg_ENABLED=1)

endif(ICU_FOUND)

if(ADA_COMPETITION)
    # URI Parser
    CPMAddPackage(
      NAME uriparser
      GITHUB_REPOSITORY uriparser/uriparser
      GIT_TAG 634b678
      OPTIONS "URIPARSER_BUILD_TESTS OFF" "URIPARSER_BUILD_DOCS OFF"
    )
    target_link_libraries(bench PRIVATE uriparser)
    target_link_libraries(bbc_bench PRIVATE uriparser)
    # URL Parser
    CPMAddPackage(
      NAME urlparser
      GITHUB_REPOSITORY netmindms/urlparser
      GIT_TAG 69c09ed
    )
    add_library(urlparser STATIC "${urlparser_SOURCE_DIR}/src/EdUrlParser.cpp")
    target_include_directories(urlparser PUBLIC "${urlparser_SOURCE_DIR}/src")
    target_link_libraries(bench PRIVATE urlparser)
    target_link_libraries(bbc_bench PRIVATE urlparser)

    # HTTP Parser
    CPMAddPackage(
      NAME httpparser
      GITHUB_REPOSITORY nodejs/http-parser
      VERSION 2.9.4
    )
    add_library(httpparser STATIC "${httpparser_SOURCE_DIR}/http_parser.c")
    set_source_files_properties("${httpparser_SOURCE_DIR}/http_parser.c" PROPERTIES LANGUAGE C)
    target_include_directories(httpparser PUBLIC "${httpparser_SOURCE_DIR}")
    target_link_libraries(bench PRIVATE httpparser)
    target_link_libraries(bbc_bench PRIVATE httpparser)


    target_compile_definitions(bench PRIVATE ADA_VARIOUS_COMPETITION_ENABLED=1)
    target_compile_definitions(bbc_bench PRIVATE ADA_VARIOUS_COMPETITION_ENABLED=1)
endif(ADA_COMPETITION)

# CURL
find_package(CURL)
if(CURL_FOUND)
    message(STATUS "curl version " ${CURL_VERSION_STRING})
    if (CURL_VERSION_STRING VERSION_LESS "7.62.0")
        message(STATUS "curl is too old, we need version 7.62.0 or better")
    else()
        include_directories(${CURL_INCLUDE_DIRS})
        if(NOT CURL_LIBRARIES)
            target_link_libraries(bench PRIVATE CURL::libcurl)
            target_link_libraries(benchdata PRIVATE CURL::libcurl)
            target_link_libraries(bbc_bench PRIVATE CURL::libcurl)
        else()
            target_link_libraries(bench PRIVATE ${CURL_LIBRARIES})
            target_link_libraries(benchdata PRIVATE ${CURL_LIBRARIES})
            target_link_libraries(bbc_bench PRIVATE ${CURL_LIBRARIES})
        endif()
        target_compile_definitions(bench PRIVATE ADA_CURL_ENABLED=1)
        target_compile_definitions(benchdata PRIVATE ADA_CURL_ENABLED=1)
        target_compile_definitions(bbc_bench PRIVATE ADA_CURL_ENABLED=1)
    endif()
else(CURL_FOUND)
    message(STATUS "Curl not found! Please install the curl library.")
endif(CURL_FOUND)

option(ADA_BOOST_URL "Whether to install boost URL." OFF)

message(STATUS "Compiler is " ${CMAKE_CXX_COMPILER_ID})

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
message(STATUS "Compiler version " ${CMAKE_CXX_COMPILER_VERSION})

if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9)
message(STATUS "Compiler is too old, disabling boost url.")
SET(ADA_BOOST_URL OFF CACHE BOOL "Whether to install boost URL." FORCE)
endif()
endif()

# Boost
if(ADA_BOOST_URL)
find_package(
    Boost 1.86
    COMPONENTS system
)
endif(ADA_BOOST_URL)

if(Boost_FOUND)
    CPMAddPackage(
      NAME boost_url
      GITHUB_REPOSITORY  boostorg/url
      GIT_TAG boost-1.81.0
    )
    add_library(boost_url INTERFACE)
    target_include_directories(boost_url INTERFACE
           "${boost_url_SOURCE_DIR}/include")

    target_link_libraries(bench PRIVATE Boost::system)
    target_link_libraries(bench PRIVATE boost_url)
    target_compile_definitions(bench PRIVATE ADA_BOOST_ENABLED=1)

    target_link_libraries(benchdata PRIVATE Boost::system)
    target_link_libraries(benchdata PRIVATE boost_url)
    target_compile_definitions(benchdata PRIVATE ADA_BOOST_ENABLED=1)

    target_link_libraries(bbc_bench PRIVATE Boost::system)
    target_link_libraries(bbc_bench PRIVATE boost_url)
    target_compile_definitions(bbc_bench PRIVATE ADA_BOOST_ENABLED=1)
else(Boost_FOUND)
if(ADA_BOOST_URL)
    message(STATUS "Boost 1.80 or better was not found, please install it for benchmarking purposes.")
endif(ADA_BOOST_URL)
endif(Boost_FOUND)

# Zuri
find_package(ZURI QUIET)
if(ZURI_FOUND)
	message(STATUS "Zuri found")
	target_link_libraries(bench PRIVATE zuri)
	target_link_libraries(benchdata PRIVATE zuri)
	target_link_libraries(bbc_bench PRIVATE zuri)

=== debian/changelog ===
nodejs (22.22.0+dfsg+~cs22.19.7-0kali1) kali-experimental; urgency=medium

  * Adapt gbp.conf for Kali
  * Embed amaro for Kali build
  * New upstream version 22.22.0+dfsg+~cs22.19.7
  * Build with amaro support

 -- Sophie Brun <sophie@kali.org>  Mon, 26 Jan 2026 13:56:18 +0100

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildtools.mk


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

builtins := /usr/share/nodejs/node

# source equivalent of nodejs -e 'console.log(process.versions.modules)'
ABI = $(shell awk '/^#define NODE_MODULE_VERSION [0-9]+/ {print $$3}' src/node_version.h)

# archs
ARCHS := amd64 arm64 armel armhf i386 mips64el mips64r6el loong64 ppc64 ppc64el riscv64 s390x

# branch
BRANCH := $(word 1, $(subst .,$(space), $(DEB_UPSTREAM_VERSION)))

LANG=C
export LANG
DEB_CONFIGURE_NORMAL_ARGS =
# without-amaro needs debian/patches/build/no-amaro-no-strip-types.patch
DEB_CONFIGURE_EXTRA_FLAGS = \
--verbose \
--without-npm \
--without-corepack \
--shared \
--shared-zlib \
--shared-zstd \
--shared-cares \
--shared-http-parser \
--shared-ngtcp2 \
--shared-nghttp3 \
--shared-nghttp2 \
--shared-brotli \
--shared-simdjson \
--shared-sqlite \
--shared-simdutf \
--shared-builtin-undici/undici-path=/usr/share/nodejs/undici/undici-fetch.js \
--shared-builtin-acorn-path=/usr/share/nodejs/acorn/dist/acorn.js \
--shared-builtin-acorn_walk-path=/usr/share/nodejs/acorn-walk/dist/walk.js \
--shared-builtin-cjs_module_lexer/lexer-path=/usr/share/nodejs/cjs-module-lexer/lexer.js \
--shared-builtin-cjs_module_lexer/dist/lexer-path=/usr/share/nodejs/cjs-module-lexer/dist/lexer.js \
--shared-builtin-minimatch-path=/usr/share/nodejs/minimatch/dist/cjs/index.bundle.js \
--shared-openssl \
--openssl-use-def-ca-store \
--with-intl=system-icu \
--prefix=/usr \
--arch-triplet=$(DEB_HOST_MULTIARCH) \
--node-relative-path="lib/$(DEB_HOST_MULTIARCH)/nodejs:share/nodejs" \
--dest-os=linux

ifneq ($(DEB_HOST_ARCH),i386)
	DEB_CONFIGURE_EXTRA_FLAGS += --shared-libuv
endif

ifneq ($(filter pkg.nodejs.nobuiltin,$(DEB_BUILD_PROFILES)),)
	DEB_CONFIGURE_EXTRA_FLAGS += --node-builtin-modules-path=$(builtins)
endif

# map HOST ARCH AND OS, and if unknown let upstream guess

destCpu =
destCpu := $(or $(destCpu),$(if $(filter i386,$(DEB_HOST_ARCH_CPU)),ia32))
destCpu := $(or $(destCpu),$(if $(filter amd64_32,$(DEB_HOST_ARCH_CPU)_$(DEB_HOST_ARCH_BITS)),x32))
destCpu := $(or $(destCpu),$(if $(filter amd64,$(DEB_HOST_ARCH_CPU)),x64))
destCpu := $(or $(destCpu),$(if $(filter mips64r6el,$(DEB_HOST_ARCH_CPU)),mips64el))
destCpu := $(or $(destCpu),$(if $(filter armhf,$(DEB_HOST_ARCH_CPU)),arm))
destCpu := $(or $(destCpu),$(if $(filter powerpc,$(DEB_HOST_ARCH_CPU)),ppc))
destCpu := $(or $(destCpu),$(if $(filter ppc64el,$(DEB_HOST_ARCH_CPU)),ppc64))
destCpu := $(or $(destCpu),$(filter arm64 loong64 mips64el ppc64 riscv64 s390x,$(DEB_HOST_ARCH_CPU)))

ifneq (, $(destOs))
DEB_CONFIGURE_EXTRA_FLAGS += --dest-os=$(destOs)
else
ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
$(error "unknown --dest-os for cross compiling nodejs to $(DEB_HOST_ARCH)")
endif
endif
ifeq (unsupported, $(destCpu))
$(error "nodejs cannot run on $(DEB_HOST_ARCH), please consult maintainers")
endif
ifneq (, $(destCpu))
DEB_CONFIGURE_EXTRA_FLAGS += --dest-cpu=$(destCpu)
else
ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
$(error "unknown --dest-cpu for cross compiling nodejs to $(DEB_HOST_ARCH)")
endif
endif

# mips32r1 or greater, detected at runtime
ifeq (mips64el, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=r2 --with-mips-fpu-mode=fp64
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif
ifeq (mips64r6el, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=r6 --with-mips-fpu-mode=fp64
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif

ifeq (armel, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-float-abi=softfp
ifeq ($(shell dpkg-vendor --is ubuntu && echo true),true)
# Ubuntu targets armv7+ with VFP and thumb2 support by default for armel
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv3
else
# debian armel version
# v8 supports armv6k (must be set explicitely) + vfpv2 (selected by default)
# armv6k is only not available on ARM1136JF-S r0p2, and available on r1p0.
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv2 --with-arm-version=6
CFLAGS += -march=armv6k -mfpu=vfpv2
CPPFLAGS += -march=armv6k -mfpu=vfpv2
endif
endif

ifeq (armhf, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-float-abi=hard
ifeq ($(shell dpkg-vendor --derives-from raspbian && echo true),true)
# enable vfp, disable armv7
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfp
else
# enable armv7 vfpv3-d16
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv3-d16
endif
endif

DEB_DESTDIR = $(CURDIR)/debian/tmp

# Compiled without amaro - no ts support
skipTests += parallel/test-cli-node-options-docs
skipTests += parallel/test-config-file
skipTests += parallel/test-util-getcallsites
skipTests += parallel/test-worker-eval-typescript
skipTests += parallel/test-node-output-eval
skipTests += parallel/test-worker-cli-options
skipTests += parallel/test-worker-load-file-with-extension-other-than-js
skipTests += parallel/test-node-output-sourcemaps
skipTests += parallel/test-runner-output
# tests using npm
skipTests += parallel/test-npm-install
skipTests += parallel/test-npm-version
skipTests += parallel/test-release-npm
# tests using network
skipTests += parallel/test-dns
skipTests += parallel/test-net-connect-immediate-finish
skipTests += parallel/test-net-better-error-messages-port-hostname
skipTests += parallel/test-https-connect-address-family
skipTests += parallel/test-tls-connect-address-family
skipTests += parallel/test-dns-cancel-reverse-lookup
skipTests += parallel/test-dns-resolveany-bad-ancount
# bad test
skipTests += parallel/test-child-process-stdio-overlapped
# requires corepack
skipTests += parallel/test-corepack-yarn-install
skipTests += parallel/test-corepack-version
# fail on buildd
skipTests += sequential/test-force-repl
skipTests += sequential/test-performance
# hangs https://github.com/nodejs/node/issues/44898
skipTests += sequential/test-watch-mode
skipTests += sequential/test-watch-mode-inspect
# CVE-2024-22017 shared libuv cannot guarantee io_uring is disabled
skipTests += parallel/test-process-uid-gid
skipTests += parallel/test-process-initgroups
skipTests += parallel/test-process-setgroups
skipTests += parallel/test-process-euid-egid
# sea requires postject
skipTests += parallel/test-single-executable-application
# loading of openssl for tests make this test fail
skipTests += parallel/test-strace-openat-openssl
# Might fail on slow architectures
flakyTests += parallel/test-runner-output
flakyTests += sequential/test-tls-session-timeout
# https://bugs.debian.org/919588
# flaky on some user environments
flakyTests += parallel/test-net-listen-after-destroying-stdin
# fails when running with eatmydata
skipTests += parallel/test-fs-error-messages
# need privileges
skipTests += parallel/test-cluster-bind-privileged-port
skipTests += parallel/test-cluster-shared-handle-bind-privileged-port
skipTests += parallel/test-debugger-preserve-breaks
# issues on 32-bit archs
skipTests += parallel/test-debugger-heap-profiler
skipTests += parallel/test-fs-utimes
skipTests += parallel/test-fs-utimes-y2K38
skipTests += parallel/test-debug-args
# https://github.com/nodejs/node/issues/27611#issuecomment-613100468
skipTests += sequential/test-cpu-prof-dir-absolute
skipTests += sequential/test-cpu-prof-exit
# Flaky in build servers
flakyTests += parallel/test-process-config
flakyTests += parallel/test-regress-GH-746
flakyTests += parallel/test-stdout-close-unref
flakyTests += parallel/test-child-process-stdout-flush-exit
flakyTests += parallel/test-net-connect-options-fd
flakyTests += sequential/test-fs-watch
flakyTests += sequential/test-http2-session-timeout
flakyTests += sequential/test-debugger-preserve-breaks
flakyTests += sequential/test-debugger-exec-scope
flakyTests += sequential/test-worker-heapsnapshot-options
flakyTests += parallel/test-http-keep-alive-empty-line
# flaky on buildd https://github.com/nodejs/node/issues/39655
flakyTests += parallel/test-cluster-primary-error

## nodejs 22.22.0+dfsg+~cs22.19.13

=== debian/changelog ===
nodejs (22.22.0+dfsg+~cs22.19.13-1) unstable; urgency=medium

  [ Bastien Roucariès ]
  * Increase build timeout
  * Add stricter acorn depends

  [ Jérémy Lal ]
  * New upstream version 22.22.0+dfsg+~cs22.19.13
  * Do not test process.versions
  * Drop ada, use ada-url
  * Disable all nghttp2 tests for now
  * Avoid useless python version check in configure. Closes: #1127459.

 -- Jérémy Lal <kapouer@melix.org>  Thu, 26 Feb 2026 23:26:49 +0100

nodejs (22.22.0+dfsg+~cs22.19.6-2) unstable; urgency=medium

  * Rebuild with newer acorn

 -- Bastien Roucariès <rouca@debian.org>  Tue, 24 Feb 2026 01:14:04 +0100

=== debian/control ===
Source: nodejs
Section: javascript
Priority: optional
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@alioth-lists.debian.net>
Uploaders: Jérémy Lal <kapouer@melix.org>,
 Jonas Smedegaard <dr@jones.dk>
Build-Depends:
 sse2-support [i386] <!nocheck>,
 armv6k-support [armel] <!nocheck>, vfpv2-support [armel] <!nocheck>,
 debhelper-compat (= 13),
 bash-completion,
 dh-sequence-bash-completion,
 ca-certificates,
 curl <!nocheck>,
 gyp (>= 0.16.0~),
 jq,
 libada-url-dev,
 libada-url-dev:native,
 libbrotli-dev,
 libbrotli-dev:native,
 libc-ares-dev (>= 1.18.1~),
 libc-ares-dev:native,
 libicu-dev (>= 73.1~),
 libicu-dev:native,
 libllhttp-dev (>= 9.3.0~),
 libllhttp-dev:native,
 libnghttp2-dev (>= 1.41.0~),
 libnghttp2-dev:native,
 libnghttp3-dev (>= 1.4.0~),
 libnghttp3-dev:native,
 libngtcp2-dev (>= 1.6.0~),
 libngtcp2-dev:native,
 libsimdjson-dev (>= 3.13.0~),
 libsimdjson-dev:native,
 libsqlite3-dev (>= 3.46.1~),
 libsqlite3-dev:native,
 libsimdutf-dev,
 libsimdutf-dev:native,
 libssl-dev (>= 1.1.1~),
 libssl-dev:native,
 libuv1-dev (>= 1.51.0~),
 libuv1-dev:native,
 node-acorn (>= 8.16.0~) <!pkg.nodejs.nobuiltin>,
 node-cjs-module-lexer (>= 1.2.2~) <!pkg.nodejs.nobuiltin>,
 node-minimatch (>= 9.0.3-5) <!pkg.nodejs.nobuiltin>,
 node-undici (>= 5.0.0~) <!pkg.nodejs.nobuiltin>,
 openssl (>= 1.1.1~) <!nocheck>,
 pkgconf,
 pkg-js-tools (>= 0.8.2~) <!nocheck>,
 python3:native,
 python3-packaging,
 procps <!nocheck>,
 zlib1g-dev,
 zlib1g-dev:native,
 libzstd-dev,
 libzstd-dev:native,
Build-Depends-Indep:
 node-js-yaml (>= 4.1.0+dfsg+~4.0.5-6) <!nodoc>,
 node-marked (>= 4~) <!nodoc>,
 node-highlight.js <!nodoc>,
Standards-Version: 4.7.2
Homepage: https://nodejs.org/
Vcs-Browser: https://salsa.debian.org/js-team/nodejs/tree/master-22.x
Vcs-Git: https://salsa.debian.org/js-team/nodejs.git -b master-22.x
Rules-Requires-Root: no

Package: libnode-dev
Section: libdevel
Architecture: amd64 arm64 armel armhf i386 mips64el mips64r6el loong64 powerpc ppc64 ppc64el riscv64 s390x
Depends: ${misc:Depends},
 libssl-dev (>= 1.1.1~),
 libuv1-dev (>= 1.33.0~),
 libnode127 (= ${binary:Version})
Breaks: nodejs-dev (<< 10.0.0~dfsg1-3)
Replaces: libv8-dev,
 nodejs-dev (<< 10.0.0~dfsg1-3)
Conflicts: libv8-dev (<= 3.14.5.8-11)
Provides: libv8-dev
Description: evented I/O for V8 javascript (development files)
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 This package provides development headers for libnode127

Package: nodejs
Architecture: amd64 arm64 armel armhf i386 mips64el mips64r6el loong64 powerpc ppc64 ppc64el riscv64 s390x
Multi-Arch: allowed
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 node-corepack <!pkg.nodejs.nobuiltin>,
 sse2-support [i386],
 armv6k-support [armel], vfpv2-support [armel],
 libnode127 (= ${binary:Version})
Recommends: ca-certificates,
 nodejs-doc,
Suggests: npm
Replaces: nodejs-legacy
 , libnode72 (<< 13)
 , libnode83 (<< 16.13.2+really14.19.1~dfsg~)
Conflicts: nodejs-legacy
Breaks: node-typescript-types (<< 20210110~)
 , node-babel-runtime (<< 7)
 , node-jest (<< 29~)
 , node-proxy-agents (<< 0~2025070717~)
 , libnode72 (<< 13)
 , libnode83 (<< 16.13.2+really14.19.1~dfsg~)
Provides: node-types-node (= ${types:Node})
Description: evented I/O for V8 javascript - runtime executable
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.

Package: libnode127
Section: libs
Architecture: amd64 arm64 armel armhf i386 mips64el mips64r6el loong64 powerpc ppc64 ppc64el riscv64 s390x
Multi-Arch: same
Depends: ${shlibs:Depends},
 ${misc:Depends},
 sse2-support [i386],
 armv6k-support [armel], vfpv2-support [armel],
 node-acorn (>= 8.16.0~) <!pkg.nodejs.nobuiltin>,
 node-cjs-module-lexer (>= 1.2.2~) <!pkg.nodejs.nobuiltin>,
 node-minimatch (>= 9.0.3-5) <!pkg.nodejs.nobuiltin>,
 node-undici (>= 5.0.0~) <!pkg.nodejs.nobuiltin>
Breaks: node-modern-syslog (<< 1.1.4-2),
 libnode64 (<< 10.24.1~),
 libnode72 (<< 13),
 libnode108 (<< 19),
 libnode109 (<< 19),
 libnode115 (<< 21),
Replaces: nodejs-legacy,
 libnode72,
 libnode83,
 libnode93,
 libnode108,
 libnode109,
 libnode115,
Conflicts: nodejs-legacy
Description: evented I/O for V8 javascript - runtime library
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 .
 This package provides the dynamic library for Node.js.

Package: nodejs-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Recommends: nodejs
Depends: ${misc:Depends}
Replaces: nodejs (<< 6.11.2~dfsg-3)
Conflicts: nodejs (<< 6.11.2~dfsg-3)
Description: API documentation for Node.js, the javascript platform
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 .
 This package contains API documentation for Node.js.

=== debian/watch ===
Version: 5

Source: https://nodejs.org/dist
Matching-Pattern: v(22\.\d+\.\d+)/
Downloadurlmangle: s/.*v(.*)\//https\:\/\/nodejs\.org\/dist\/v$1\/node\-v$1\.tar\.xz/
Dversionmangle: auto
Filenamemangle: s/.*v(.*)\/$/nodejs-$1\.tar\.xz/
Repacksuffix: +dfsg
Version-Schema: group

# IMPORTANT: do NOT upgrade @types/node when target is debian/stable,
# it will break some debian packages, and some users packages too.
# It is not recommended use npmregistry. Please investigate more.
# Take a look at https://wiki.debian.org/debian/watch/
Component: types-node
Template: Npmregistry
Ctype: nodejs
Dist: @types/node
Matching-Pattern: https://registry.npmjs.org/@types/node/-/node-(22\.\d+\.\d+)@ARCHIVE_EXT@
Version-Schema: checksum

## nodejs 24.11.1+dfsg+~cs24.10.1

=== debian/changelog ===
nodejs (24.11.1+dfsg+~cs24.10.1-1) experimental; urgency=medium

  * New upstream version 24.11.1+dfsg+~cs24.10.1
  * Update soname to libnode137
  * Update to ada 3.3.0
  * copyright:
    + exclude more minified files
    + fix many oversights
  * Patch v8 to use shared simdutf
  * Patch to fix 32-bit builds
  * Switch to DEP-14 and simplify Vcs-* fields
  * Can build twice in a row
  * Upstream fix for highway/gcc15 on ppc64el/s390x
  * Improve test timeout multiplier patch
  * Skip new tests depending on amaro

 -- Jérémy Lal <kapouer@melix.org>  Wed, 10 Dec 2025 10:23:07 +0100

=== debian/control ===
--- 
+++ 
@@ -14,8 +14,6 @@
  curl <!nocheck>,
  gyp (>= 0.16.0~),
  jq,
- libada-url-dev,
- libada-url-dev:native,
  libbrotli-dev,
  libbrotli-dev:native,
  libc-ares-dev (>= 1.18.1~),
@@ -40,7 +38,7 @@
  libssl-dev:native,
  libuv1-dev (>= 1.51.0~),
  libuv1-dev:native,
- node-acorn (>= 8.16.0~) <!pkg.nodejs.nobuiltin>,
+ node-acorn (>= 6.2.1~) <!pkg.nodejs.nobuiltin>,
  node-cjs-module-lexer (>= 1.2.2~) <!pkg.nodejs.nobuiltin>,
  node-minimatch (>= 9.0.3-5) <!pkg.nodejs.nobuiltin>,
  node-undici (>= 5.0.0~) <!pkg.nodejs.nobuiltin>,
@@ -60,8 +58,8 @@
  node-highlight.js <!nodoc>,
 Standards-Version: 4.7.2
 Homepage: https://nodejs.org/
-Vcs-Browser: https://salsa.debian.org/js-team/nodejs/tree/master-22.x
-Vcs-Git: https://salsa.debian.org/js-team/nodejs.git -b master-22.x
+Vcs-Browser: https://salsa.debian.org/js-team/nodejs
+Vcs-Git: https://salsa.debian.org/js-team/nodejs.git
 Rules-Requires-Root: no
 
 Package: libnode-dev
@@ -70,7 +68,7 @@
 Depends: ${misc:Depends},
  libssl-dev (>= 1.1.1~),
  libuv1-dev (>= 1.33.0~),
- libnode127 (= ${binary:Version})
+ libnode137 (= ${binary:Version})
 Breaks: nodejs-dev (<< 10.0.0~dfsg1-3)
 Replaces: libv8-dev,
  nodejs-dev (<< 10.0.0~dfsg1-3)
@@ -83,7 +81,7 @@
  efficient, perfect for data-intensive real-time applications that run
  across distributed devices.
  .
- This package provides development headers for libnode127
+ This package provides development headers for libnode137
 
 Package: nodejs
 Architecture: amd64 arm64 armel armhf i386 mips64el mips64r6el loong64 powerpc ppc64 ppc64el riscv64 s390x
@@ -94,7 +92,7 @@
  node-corepack <!pkg.nodejs.nobuiltin>,
  sse2-support [i386],
  armv6k-support [armel], vfpv2-support [armel],
- libnode127 (= ${binary:Version})
+ libnode137 (= ${binary:Version})
 Recommends: ca-certificates,
  nodejs-doc,
 Suggests: npm
@@ -122,7 +120,7 @@
  System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
  HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 
-Package: libnode127
+Package: libnode137
 Section: libs
 Architecture: amd64 arm64 armel armhf i386 mips64el mips64r6el loong64 powerpc ppc64 ppc64el riscv64 s390x
 Multi-Arch: same
@@ -130,7 +128,7 @@
  ${misc:Depends},
  sse2-support [i386],
  armv6k-support [armel], vfpv2-support [armel],
- node-acorn (>= 8.16.0~) <!pkg.nodejs.nobuiltin>,
+ node-acorn (>= 6.2.1~) <!pkg.nodejs.nobuiltin>,
  node-cjs-module-lexer (>= 1.2.2~) <!pkg.nodejs.nobuiltin>,
  node-minimatch (>= 9.0.3-5) <!pkg.nodejs.nobuiltin>,
  node-undici (>= 5.0.0~) <!pkg.nodejs.nobuiltin>
@@ -140,6 +138,7 @@
  libnode108 (<< 19),
  libnode109 (<< 19),
  libnode115 (<< 21),
+ libnode127 (<< 23),
 Replaces: nodejs-legacy,
  libnode72,
  libnode83,
@@ -147,6 +146,7 @@
  libnode108,
  libnode109,
  libnode115,
+ libnode127,
 Conflicts: nodejs-legacy
 Description: evented I/O for V8 javascript - runtime library
  Node.js is a platform built on Chrome's JavaScript runtime for easily

=== debian/rules ===
--- 
+++ 
@@ -26,6 +26,7 @@
 --verbose \
 --without-npm \
 --without-corepack \
+--without-amaro \
 --shared \
 --shared-zlib \
 --shared-zstd \
@@ -140,6 +141,13 @@
 skipTests += parallel/test-worker-load-file-with-extension-other-than-js
 skipTests += parallel/test-node-output-sourcemaps
 skipTests += parallel/test-runner-output
+skipTests += parallel/test-runner-global-setup-teardow
+skipTests += parallel/test-runner-run-global-hooks
+skipTests += parallel/test-compile-cache-typescript-commonjs
+skipTests += parallel/test-compile-cache-typescript-esm
+skipTests += parallel/test-compile-cache-typescript-strip-miss
+skipTests += parallel/test-compile-cache-typescript-strip-sourcemaps
+skipTests += parallel/test-compile-cache-typescript-transform
 # tests using npm
 skipTests += parallel/test-npm-install
 skipTests += parallel/test-npm-version
@@ -198,11 +206,3 @@
 flakyTests += parallel/test-stdout-close-unref
 flakyTests += parallel/test-child-process-stdout-flush-exit
 flakyTests += parallel/test-net-connect-options-fd
-flakyTests += sequential/test-fs-watch
-flakyTests += sequential/test-http2-session-timeout
-flakyTests += sequential/test-debugger-preserve-breaks
-flakyTests += sequential/test-debugger-exec-scope
-flakyTests += sequential/test-worker-heapsnapshot-options
-flakyTests += parallel/test-http-keep-alive-empty-line
-# flaky on buildd https://github.com/nodejs/node/issues/39655
-flakyTests += parallel/test-cluster-primary-error

## nodejs 24.12.0+dfsg+~cs24.10.4

=== debian/changelog ===
nodejs (24.12.0+dfsg+~cs24.10.4-1) experimental; urgency=medium

  * New upstream version 24.12.0+dfsg+~cs24.10.4
  * Refresh patches

 -- Jérémy Lal <kapouer@melix.org>  Sat, 20 Dec 2025 16:18:47 +0100

nodejs (24.11.1+dfsg+~cs24.10.1-2) experimental; urgency=medium

  * Use our typescript.js as fixture for snapshots tests
  * Breaks typescript << 5.2, because node types use new features,
    rendering almost all ts modules uncompilable.

 -- Jérémy Lal <kapouer@melix.org>  Sun, 14 Dec 2025 23:20:47 +0100

## nodejs 24.13.0%2Bdfsg%2B~cs24.10.7

=== debian/changelog ===
nodejs (24.13.0+dfsg+~cs24.10.7-2) experimental; urgency=medium

  * Properly mention the CVE numbers this version fixes:
    + CVE-2025-59465 lib: add TLSSocket default error handler
    + CVE-2025-55132 lib: disable futimes when permission model is enabled
    + CVE-2025-55130 lib,permission: require full read and write to symlink APIs
    + CVE-2025-59466 src: rethrow stack overflow exceptions in async_hooks
    + CVE-2025-55131 src,lib: refactor unsafe buffer creation to remove zero-fill toggle
    + CVE-2026-21637 tls: route callback exceptions through error handlers

 -- Jérémy Lal <kapouer@melix.org>  Tue, 13 Jan 2026 16:10:31 +0100

nodejs (24.13.0+dfsg+~cs24.10.7-1) experimental; urgency=medium

  * New upstream version 24.13.0+dfsg+~cs24.10.7
  * patch: export libplatform symbols in shared libnode

 -- Jérémy Lal <kapouer@melix.org>  Tue, 13 Jan 2026 15:48:38 +0100

=== debian/watch ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Version: 5
 
 Source: https://nodejs.org/dist
-Matching-Pattern: v(22\.\d+\.\d+)/
+Matching-Pattern: v(24\.\d+\.\d+)/
 Downloadurlmangle: s/.*v(.*)\//https\:\/\/nodejs\.org\/dist\/v$1\/node\-v$1\.tar\.xz/
 Dversionmangle: auto
 Filenamemangle: s/.*v(.*)\/$/nodejs-$1\.tar\.xz/
@@ -16,5 +16,10 @@
 Template: Npmregistry
 Ctype: nodejs
 Dist: @types/node
-Matching-Pattern: https://registry.npmjs.org/@types/node/-/node-(22\.\d+\.\d+)@ARCHIVE_EXT@
+Matching-Pattern: https://registry.npmjs.org/@types/node/-/node-(24\.\d+\.\d+)@ARCHIVE_EXT@
 Version-Schema: checksum
+
+Component: ada
+Template: Github
+Owner: ada-url
+Project: ada
